/*
 * Aipo is a groupware program developed by Aimluck,Inc.
 * Copyright (C) 2004-2008 Aimluck,Inc.
 * http://aipostyle.com/
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
package com.aimluck.eip.hanyo;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import org.apache.cayenne.ObjectId;
import org.apache.cayenne.access.DataContext;
import org.apache.cayenne.exp.Expression;
import org.apache.cayenne.exp.ExpressionFactory;
import org.apache.cayenne.query.SelectQuery;
import org.apache.jetspeed.services.logging.JetspeedLogFactoryService;
import org.apache.jetspeed.services.logging.JetspeedLogger;
import org.apache.turbine.util.RunData;
import org.apache.velocity.context.Context;
import com.aimluck.eip.cayenne.om.portlet.ImwMHanyo;
import com.aimluck.eip.common.ALAbstractCheckList;
import com.aimluck.eip.orm.DatabaseOrmService;
import com.aimluck.eip.util.ALEipUtils;

/**
 * 汎用マスタを複数削除するためのクラス． <BR>
 * 
 */
public class HanyoMultiDelete extends ALAbstractCheckList {

  /** logger */
  private static final JetspeedLogger logger = JetspeedLogFactoryService
      .getLogger(HanyoMultiDelete.class.getName());

  /**
   * 
   * @param rundata
   * @param context
   * @param values
   * @param msgList
   * @return
   * @see com.aimluck.eip.common.ALAbstractCheckList#action(org.apache.turbine.util.RunData,
   *      org.apache.velocity.context.Context, java.util.ArrayList,
   *      java.util.ArrayList)
   */
  protected boolean action(RunData rundata, Context context, ArrayList values,
      ArrayList msgList) {

    try {
      DataContext dataContext = DatabaseOrmService.getInstance()
          .getDataContext();
      Expression exp = ExpressionFactory.inDbExp(ImwMHanyo.HANYO_ID_PK_COLUMN,
          values);
      SelectQuery query = new SelectQuery(ImwMHanyo.class, exp);
      List ulist = dataContext.performQuery(query);
      if (ulist == null || ulist.size() == 0)
        return false;

      int size = ulist.size();
      String[] user_name_list = new String[size];

      for (int i = 0; i < size; i++) {
        ImwMHanyo record = (ImwMHanyo) ulist.get(i);
        String hanyo_id = String.valueOf(record.getHanyoId());
        user_name_list[i] = hanyo_id;
        if (hanyo_id == null)
          return false;

        // 汎用マスタを論理削除
        ObjectId oid_hanyo = new ObjectId("ImwMHanyo",
            ImwMHanyo.HANYO_ID_PK_COLUMN, hanyo_id);

        ImwMHanyo imwMHanyo = (ImwMHanyo) dataContext.refetchObject(oid_hanyo);

        imwMHanyo.setDisabled("T");

        imwMHanyo.setUpdateUserId(ALEipUtils.getUserId(rundata));

        Date now = new Date();

        imwMHanyo.setUpdateDate(now);

        dataContext.commitChanges();

      }
      return true;
    } catch (Exception e) {
      logger.error("Exception", e);
      return false;
    }
  }
}
